char errortitle[] = "Error";
char outofmemory[] = "Out of memory.";
char outofmemoryprompt[] = "Actions:\nPress C to terminate, or K to kill the currently executing VPU console.\nPress any other key to continue.";

void nomemory(void)
{
  int c;

  if(!running_console || running_console && !((struct console_struct *)running_console->function_status)->vcpu->exiting)
  {
    running_window = 0;
    video_mode(0x03);
    puts(outofmemory);      
    puts(outofmemoryprompt);
    c = getch();
    if(running_console && ((struct console_struct *)running_console->function_status)->vcpu)            
      switch(c)
      {
        case 67: case 99:
          send_vpu_signal(((struct console_struct *)running_console->function_status)->vcpu, SIGTERM);
          break;
        case 75: case 107:
          ((struct console_struct *)running_console->function_status)->vcpu->exiting = 1;
          ((struct console_struct *)running_console->function_status)->console_kill = 1;          
      }
    restore_videomode();
    draw_screen();          
  }
}

void show_error_code(int error_code)
{
  char *errormsg = malloc(100 * sizeof(char));
  if(!errormsg)
  {
    nomemory();
    return;
  }
  sprintf(errormsg, "Error code: %i", error_code);
  dialog(20, 20, 150, 100, 0, 1, 1, errormsg, errortitle, "This dialog shows error codes.");
  free(errormsg);
}

void show_error_msg(char *errormsg)
{
/*    video_mode(0x03);
    puts(errormsg);
    getch();
    restore_videomode();;*/
  dialog(20, 20, 250, 50, 0, 0, 0, errormsg, errortitle, 0);
}
