void (__interrupt __far *prev_int_23)(void);

/*
Sets the original 0x23 interrupt
*/
void reset_int23(void)
{
  _dos_setvect( 0x23, prev_int_23 );
}

// break key handler
void __interrupt int23handler(void)
{
  draw_screen();
  ungetch(3);
}

void set_int23(void)
{
  prev_int_23 = _dos_getvect( 0x23 ); 
  _dos_setvect(0x23, int23handler);
}
