#include <stdlib.h>
#include <stdio.h>
#include <dos.h>

#include "vpustrct.c"
#include "../structs.c"
//#include "../globals.c"
#include "../constrct.c"


extern unsigned vpu_hwint_count;
extern struct vpu_hw_int *vpu_hardware_int_table;
extern unsigned window_count;
extern struct prog_window **windows;
extern struct prog_window *running_window;
extern unsigned steps;

//void __far *int_to_vpu_next_handler = 0;
//extern void (__far __interrupt *int_to_vpu_next_handler)();
//extern unsigned long int_to_vpu_next_handler;

//char viesti[100];
int vpuconsole_program(struct prog_window *window, int args, int *keypress);

void set_vpu_turn(struct vpu *vpu)
{
  struct vpu *parent = vpu;
  unsigned n;

  while(parent->parent)
  {
    parent = parent->parent;
    for(n=parent->child_count;n--;)
      if(parent->child[parent->child_count] == vpu)
      {
        parent->child_running = n;
        break;
      }
  }

  steps = vpu->priority;

  for(n=window_count;n--;)
    if(windows[n]->function_pointer == vpuconsole_program &&
      ((struct console_struct*)windows[n]->function_status)->orig_vpu == parent)
    {
      running_window = windows[n];
      break;
    }  
}

void int_to_vpu(unsigned char interrupt_triggered);
#pragma aux int_to_vpu parm [ax]
void int_to_vpu(unsigned char interrupt_triggered)
{
  unsigned n = vpu_hwint_count;
//  struct vpu *vpu;
//  struct vpu *parent;

  while(n--)
    if(vpu_hardware_int_table[n].hw_int == interrupt_triggered)
      break;


  set_vpu_turn(vpu_hardware_int_table[n].vpu);

  vpu_hardware_int_table[n].vpu->interrupt_wait = vpu_hardware_int_table[n].vpu_int;
    
/*  parent = vpu = vpu_hardware_int_table[n].vpu;

  vpu->interrupt_wait = vpu_hardware_int_table[n].vpu_int;

  while(parent->parent)
  {
    parent = parent->parent;
    for(n=parent->child_count;n--;)
      if(parent->child[parent->child_count] == vpu)
      {
        parent->child_running = n;
        break;
      }
  }

  steps = vpu->priority;

  for(n=window_count;n--;)
    if(windows[n]->function_pointer == vpuconsole_program &&
      ((struct console_struct*)windows[n]->function_status)->orig_vpu == parent)
    {
      running_window = windows[n];
//      running_window->minimized = 0;
      break;
    }*/
}
