REM Type "build.bat debug" if you want to make a debug build.
echo Building the main program...

wasm -q vpu\vpudint.asm

if "%1"=="debug" goto debug_build

wcc -dMAIN -s -ml -os -ox -oh -q main.c
wcc -s -ml -os -ox -oh -q vpu\console\vpu_main.c
wcc -s -ml -zu -ox -oh -q vpu\serwrite.c
wcc -s -ml -ox -oh -q drvmod\drivers.c
rem wcc -s -ml -od -q drvmod\drivers.c
wcc -s -ml -zu -ox -oh -q drvmod\drvinst.c
wcc -s -ml -os -zu -ox -oh -q -r vpu\vpuhwint.c
wcc -s -ml -os -ox -oh -q xpmparse\xpmparse.c

goto link
:debug_build
wcc -s -ml -os -zu dalloc.c
wcc -dDEBUG_ON -dMAIN -ee -ep -en -ml -os main.c
wcc -dDEBUG_ON -ee -ep -en -ml -os vpu\console\vpu_main.c
wcc -dDEBUG_ON -ee -ep -en -ml -os -zu vpu\serwrite.c
wcc -dDEBUG_ON -ee -ep -en -ml -os drvmod\drivers.c
wcc -dDEBUG_ON -ee -ep -en -ml -os -zu drvmod\drvinst.c
wcc -dDEBUG_ON -ee -ep -en -ml -os -zu -r vpu\vpuhwint.c
wcc -dDEBUG_ON -ee -ep -en -ml -os xpmparse\xpmparse.c

link.bat debug
goto endbuild

:link
link.bat

:endbuild

echo on
