int con_stdout_write(unsigned char c);

void vpu_instr_printstr(struct vpu *vpu)
{
//  unsigned data_pointer = vpu->code[vpu->ip++]<<8;
//  data_pointer |= vpu->code[vpu->ip++];
  unsigned short data_pointer = vpu->regs[vpu->code[vpu->code_segment][vpu->ip++] & 0x07];

  if(debug)
  {
    sprintf(message, "String is in address 0x%.2X", data_pointer);
    putstr(message);
  }

  if(!memory_allowed(vpu, data_pointer))
  {
    if(debug)
    {
      sprintf(message, "  Pointer value is too big!");
      putstr(message);
    }
    return;
  }

  while(memory_allowed(vpu, data_pointer) && vpu->data[vpu->data_segment][data_pointer])
  {
    //putc(vpu->data[vpu->data_segment][data_pointer++], stdout);
//    printchar(vpu->data[vpu->data_segment][data_pointer++]);
    con_stdout_write(vpu->data[vpu->data_segment][data_pointer++]);
  }
  con_stdout_write(10);
//  inc_row();
/*  if(*cursor_row == SCR_ROWS)
    scroll_up();
  else
    *cursor_row++;
  *cursor_col=0;
  refresh();*/
//  putc('\n', stdout);
}


