void vpu_instr_sconvw(struct vpu *vpu)
{
  unsigned char reg0 = vpu->code[vpu->code_segment][vpu->ip++];
  unsigned char reg1 = vpu->code[vpu->code_segment][vpu->ip++];
  signed short *destwp = (signed short*)&vpu->regs[reg0 & 0x07];

  if(debug)
  {
    sprintf(message, "  Instruction: SCONVW 0x%X 0x%X\n", reg0, reg1);
    putstr(message);
  }

/*  if(reg1 & 0x80)
    *destwp = *(signed char*)&vpu->regs[reg1 & 0x0F];

  else*/
    *destwp = *(signed char*)&vpu->byteregs[reg1 & 0x0F];
}

void vpu_instr_sconvb(struct vpu *vpu)
{
  unsigned char reg0 = vpu->code[vpu->code_segment][vpu->ip++];
  unsigned char reg1 = vpu->code[vpu->code_segment][vpu->ip++];

  if(debug)
  {
    sprintf(message, "  Instruction: SCONVB 0x%X 0x%X\n", reg0, reg1);
    putstr(message);
  }

/*  if(reg0 & 0x80)
    vpu->regs[reg0 & 0x0F] = *(signed char*)&vpu->regs[reg1 & 0x0F];

  else*/
    vpu->byteregs[reg0 & 0x0F] = *(signed char*)&vpu->regs[reg1 & 0x07];
}
