int vpuwindow_program(struct prog_window *window, int args, int *keypress)
{
  struct vpu_progwindow *status = window->function_status;
  unsigned n,m;

  if(keypress)
  {
    status->keybuff[0] = *keypress;
    if(!*keypress)
      status->keybuff[1] = getch();      
    *keypress = -1;
  }
  if(args >= 0)
  {
    for(n=0,m=0;n<window->element_count;n++)
    {
      if(window->window_grid[n]->type == 0)
        m++;
      if(m == args) break;
    }
    args += m;
    
    status->keybuff[0] = 0x0100 + args;
    if(window->window_grid[args]->type == 2)
    {
      edit_text(window, args);
      strcpy((char*)window->window_grid[args]->connect_value, window->window_grid[args]->text);
    }
  }
  
  return args + 100;
}

struct prog_window *init_vpuprog_window(unsigned x, unsigned y, unsigned char *title, unsigned mouse_int, unsigned mouse_port, void *vpu)
{
  struct prog_window *retval;
//  struct window_element *element;
  struct vpu_progwindow *status;

  if(!(retval = new_window(-1, -1, x, y, title, 0, 1, 0, 0, &vpuwindow_program)))
  {
    return 0;
  }

  retval->function_status = calloc(1, sizeof(struct vpu_progwindow));
  status = retval->function_status;
//  status->vcpu = ((struct console_struct*)running_console->function_status)->vcpu;
  status->keybuff[0] = -1;
  status->vcpu = vpu;
  status->mouse_int = mouse_int;
  status->mouse_port = mouse_port;
//  if(kbhit())
//    getch();

  return retval;
  
}
